<?php

defined('BASEPATH') OR exit('No direct script access allowed');

// This can be removed if you use __autoload() in config.php OR use Modular Extensions
/** @noinspection PhpIncludeInspection */
require APPPATH . '/libraries/REST_Controller.php';

// use namespace
use Restserver\Libraries\REST_Controller;

/**
 * This is an example of a few basic user interaction methods you could use
 * all done with a hardcoded array
 *
 * @package         CodeIgniter
 * @subpackage      Rest Server
 * @category        Controller
 * @author          Phil Sturgeon, Chris Kacerguis
 * @license         MIT
 * @link            https://github.com/chriskacerguis/codeigniter-restserver
 */
class Monev_satker extends REST_Controller {

    function __construct()
    {
        // Construct the parent class
        parent::__construct();

        $this->load->model('evakip/M_monev_sakip','Model');
        $this->load->model('home/M_dashboard','ModDash');
        $this->db2 = $this->load->database('evakip', TRUE);
    }

    public function users_post()
    {
        $jenis_laporan = $this->post('jenis_laporan',TRUE);
   
        $date_start = $this->post('start_date',TRUE);
        $date_end = $this->post('end_date',TRUE);
        $targetYear = substr($date_end,0,4);
        
        $qTar = $this->ModDash->getTarByIndi($jenis_laporan,$targetYear);

        $alur_perkara_id = '';
        if(in_array($jenis_laporan,array(1,2,21,22)))
        {
            if($jenis_laporan=='1')
            {
                $alur_perkara_id = ' in  ("1","2","3","4","5","7","8","18")  ';
            }elseif($jenis_laporan=='2')
            {
                $alur_perkara_id = ' in (111,112,113,118,119)  ';
            }elseif($jenis_laporan=='21')
            {
                $alur_perkara_id = ' = 6  ';
            }elseif($jenis_laporan=='22')
            {
                $alur_perkara_id = ' = 115  ';
            }
            $q = $this->Model->getPerkaraTepatWaktu($date_start,$date_end,$alur_perkara_id,$jenis_laporan);
        }

        if($jenis_laporan=='3'){
            $q = $this->Model->getRJ($date_start,$date_end,$jenis_laporan);
        }elseif($jenis_laporan=='4'){
            $q = $this->Model->getTidakBanding($date_start,$date_end,$alur_perkara_id);
        }elseif($jenis_laporan=='5'){
            $q = $this->Model->getTidakKasasi($date_start,$date_end,$alur_perkara_id);
        }elseif($jenis_laporan=='6'){
            $q = $this->Model->getDiversi($date_start,$date_end,$alur_perkara_id);
        }elseif($jenis_laporan=='7'){
            $q = $this->Model->getPersepsiIKM($date_start,$date_end,$alur_perkara_id);
        }elseif($jenis_laporan=='8') {
            $q = $this->Model->getPemberitahuanPutusanPerdata($date_start,$date_end,$alur_perkara_id);
        }elseif($jenis_laporan=='9'){
            $q = $this->Model->getPemberitahuanPutusanPidana($date_start,$date_end,$alur_perkara_id);
        }elseif($jenis_laporan=='10'){
            $q = $this->Model->getMediasi($date_start,$date_end,$alur_perkara_id); 
        }elseif($jenis_laporan=='11'){
            $q = $this->Model->getProdeo($date_start,$date_end,$alur_perkara_id);
        }elseif($jenis_laporan=='12'){
            $q = $this->Model->getSidangKeliling($date_start,$date_end,$alur_perkara_id); 
        }elseif($jenis_laporan=='13'){
            $q = $this->Model->getPosbakum($date_start,$date_end,$alur_perkara_id);
        }elseif($jenis_laporan=='14'){
            $q = $this->Model->getEksekusi($date_start,$date_end,$alur_perkara_id); 
        }

        if(empty($q)){
            $this->set_response([
                'status' => FALSE,
                'message' => 'invalid paramater'
            ], REST_Controller::HTTP_BAD_REQUEST); // NOT_FOUND (404) being the HTTP response code
        }

        $message = [
            'jenis_laporan' => $this->post('jenis_laporan'),
            'start_date' => $this->post('start_date'),
            'end_date' => $this->post('end_date'),
            'message' => 'FOUND',
            'target' => $qTar->row(),
            "result" => $q->row(),
        ];

        $this->set_response($message, REST_Controller::HTTP_OK); // CREATED (201) being the HTTP response code
    }


}
