<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Target extends MY_Controller {
    function __construct() {
        parent::__construct();
        if($this->session->userdata('is_logged_in')==FALSE){ redirect('login/Login'); }
        // $this->load->model('evakip/M_monev_sakip','Model_eval');
        $this->load->model('evakip/M_target','Model');
        $this->db2 = $this->load->database('evakip', TRUE);

    }

    public function index()
    {
        $data['sys_config'] = $this->db->get('sys_config');
        $data['page'] ='evakip/target';
        $this->template->admin($data);
    }

    public function showdatatarget()
    {
        $query = $this->Model->get_datatables();
        $data = array();
        $no = $_POST['start'];
        foreach ($query as $row) {
            $act = '<a onclick="loadModalInput(\''.base64_encode($this->encryption->encrypt($row->id)).'\')" href="#!" class="text-dark" ><i class="fa fa-edit"></i></a> | <a href="#!" class="text-body" onclick="delData(\''.base64_encode($this->encryption->encrypt($row->id)).'\')"><i class="fa fa-trash"></i></a>';
            $unit = ($row->satuan_unit=='1' ? 'Persentase' : 'Perkara');
            $no++;
            $UserData = array();
            $UserData[] = "<div align='center'>".$no."</div>";
            $UserData[] = "<div align='left' class='text-primary'>".$row->namaiku."</div>";
            $UserData[] = "<div align='center' class='font-weight-bold'>".$row->tahun."</div>";
            $UserData[] = '<div align="center" class="font-weight-bold">'.$row->target.'</div>';
            $UserData[] = '<div align="center">'.$unit.'</div>';
            $UserData[] = "<div align='center'>".$row->keterangan."</div>";
            $UserData[] = "<div align='center'>".$act."</div>";
            $data[] = $UserData;
        }

        $json_data = array(
                "draw" => $_POST['draw'],
                "recordsTotal" => $this->Model->count_all(),
                "recordsFiltered" => $this->Model->count_filtered(),
                "data" => $data,
                );
        echo json_encode($json_data);
    }

    public function loadModalDataTarget()
    {
        $enc = $this->input->post('enc',true);
        $idTrx = $this->encryption->decrypt(base64_decode($enc));

        $qIndikator = $this->Model->getIndikator();
        $arrIndikator = array('0'=>'--pilih indikator--');
        foreach($qIndikator->result() as $row)
        {
            $arrIndikator[$row->id] = $row->urutan.'. '.$row->nama; 
        }

        $year = date('Y');
        $yearSel = $year+1;
        $arrYear = array('0'=>'--pilih tahun--');
        for($i =  $yearSel; $i >= 2020; $i--) {
            $arrYear[$i] = $i;
        }

        if($idTrx=='-1')
        {
            $ddIndikator = form_dropdown('indikator', $arrIndikator,'', 'id="indikator" name="indikator" class="select2" style="width:100%;" ');
            $ddYear = form_dropdown('tahunSel', $arrYear,'', 'id="tahunSel" name="tahunSel" class="select2" style="width:40%;" ');
            $target = '';
            $keterangan = '';

        }else{
            $q = $this->db2->get_where('trx_target',array('id'=>$idTrx));
            $dt = $q->row();
            $id_indikator = $dt->id_indikator;
            $tahun = $dt->tahun;
            $target = $dt->target;
            $keterangan = $dt->keterangan;
            $ddIndikator = form_dropdown('indikator', $arrIndikator,$id_indikator, 'id="indikator" name="indikator" class="select2" style="width:100%;" ');
            $ddYear = form_dropdown('tahunSel', $arrYear,$tahun, 'id="tahunSel" name="tahunSel" class="select2" style="width:40%;" ');

        }


        echo json_encode(array('st'=>'1','enc'=>$enc,'ddIndikator'=>$ddIndikator,'ddYear' => $ddYear,'target'=>$target,'keterangan'=>$keterangan,'keterangan'=>$keterangan));
    }

    public function saveDataTarget()
    {
        // exit();
        $this->form_validation->set_rules('enc','enc','trim|required');
        $this->form_validation->set_rules('indikator','Indikator','trim|required');
        $this->form_validation->set_rules('tahunSel','Tahun','trim|required');
        $this->form_validation->set_rules('inputTarget','Target','trim|required');
        if ($this->form_validation->run() == FALSE){
            echo json_encode(array('st'=>0,'msg'=>'Tidak Berhasil:<br/>'.validation_errors()));
            return;
        }

        $enc = $this->input->post('enc',true);
        $idTrx = $this->encryption->decrypt(base64_decode($enc));
        $tahun = $this->input->post('tahunSel',true);
        $indikator = $this->input->post('indikator',true);
        $target = $this->input->post('inputTarget',true);
        $keterangan = $this->input->post('inputKeterangan',true);
        
        if(empty($tahun) OR $tahun=='0')
        {
            echo json_encode(array('st'=>'0','msg'=>'Pilih Tahun Target!!'));
            exit();
        }

        if($idTrx=='-1')
        {
            $qIfExist = $this->db2->get_where('trx_target',array('id_indikator'=>$indikator,'tahun'=>$tahun));
            if($qIfExist->num_rows() > 0)
            {
                echo json_encode(array('st'=>0,'msg'=>'Data sudah ada, silahkan gunakan tombol edit untuk memperbaharui!!'));
                return ;
            }

            $dataIns = array(
                'id_indikator' => $indikator , 
                'tahun' => $tahun,
                'target' => $target,
                'keterangan' => $keterangan,
                'diinput_oleh' => $this->session->userdata('username'),
                'diinput_tanggal' => date("Y-m-d H:i:s",time())
            );
            $qSave = $this->db2->insert('trx_target',$dataIns);
            $msg = 'Target Tahun '.$tahun.' berhasil ditambahkan';
        }else{
            $dtUpdate = array(
                'id_indikator' => $indikator , 
                'tahun' => $tahun,
                'target' => $target,
                'keterangan' => $keterangan,
                'diperbaharui_oleh' => $this->session->userdata('username'),
                'diperbaharui_tanggal' => date("Y-m-d H:i:s",time())
            );
            $qSave = $this->db2->update('trx_target',$dtUpdate,array('id'=>$idTrx));
            $msg = 'Target Tahun '.$tahun.' berhasil diperbaharui';
        }

        if($qSave)
        {
            echo json_encode(array('st'=>'1','msg'=>$msg));
        }else{
            echo json_encode(array('st'=>'1','msg'=>'operation failed!!'));
        }
    }

    public function delTarget()
    {
        $this->form_validation->set_rules('enc','Enc','trim|required');
        if ($this->form_validation->run() == FALSE){
            echo json_encode(array('st'=>0,'msg'=>'Tidak Berhasil:<br/>'.validation_errors()));
            return;
        }

        $enc = $this->input->post('enc',true);
        $idTrx = $this->encryption->decrypt(base64_decode($enc));

        $qDel = $this->db2->delete('trx_target',array('id'=>$idTrx));
        if($qDel)
        {
            echo json_encode(array('st'=>'1','msg'=>'Data Target Berhasil Dihapus'));
        }else
        {
            echo json_encode(array('st'=>'0','msg'=>'Data Target Gagal Dihapus'));   
        }

    }



}
