<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Home extends MY_Controller {
    function __construct() {
        parent::__construct();
        // $this->load->model('evakip/M_monev_sakip','Model_eval');
        $this->load->model('evakip/M_monev_sakip','Model');
        $this->load->model('M_dashboard','Model_dash');
        $this->db2 = $this->load->database('evakip', TRUE);
    }

    public function index()
    {
        $post = $this->input->post();
        if(!empty($post)){
			$month_start = $this->input->post('month_start');
			$year_start = $this->input->post('year_start');
            $month_end = $this->input->post('month_end');
			$year_end = $this->input->post('year_end');
		}else{
			$month_start = '01';
			$year_start = date('Y');
            $month_end = date('m');
			$year_end = date('Y');
		}

        $year = $year_end;
        $data['year'] = $year_end;
        $data['bulan_mulai'] = $month_start;
        $data['tahun_mulai'] = $year_start;
        $data['bulan_akhir'] = $month_end;
        $data['tahun_akhir'] = $year_end;

        $arrMonth = array(
            '' => '--pilih bulan--',
            '01' => 'Januari',
            '02' => 'Februari',
            '03' => 'Maret',
            '04' => 'April',
            '05' => 'Mei',
            '06' => 'Juni',
            '07' => 'Juli',
            '08' => 'Agustus',
            '09' => 'September',
            '10' => 'Oktober',
            '11' => 'November',
            '12' => 'Desember');
        
        $qYear = $this->Model->getTahunPerkara();
        $arrYear = array();
        $arrYear['0'] = "--pilih tahun--";
        foreach($qYear->result() as $row)
        {
            $arrYear[$row->year_sel] = $row->year_sel; 
        }
        $data['arrYear'] = $arrYear;
        $data['arrMonth'] = $arrMonth;
        $date_start = $year_end.'-01';
        $date_end = $year_end.'-12';
        $alur_perkara_id = '';

        $data['qTarget'] = $this->Model_dash->getTarget($year);
        $data['qGlobalIndikator'] = $this->Model_dash->globalIndikator($year);
        $data['qKasasi'] = $this->Model->getTidakKasasi($date_start,$date_end,$alur_perkara_id);
        $data['qTrxLaporanIKM'] = $this->Model->getPersepsiIKM($date_start,$date_end,$alur_perkara_id);
        $data['qPemberitahuanPerdata'] = $this->Model->getPemberitahuanPutusanPerdata($date_start,$date_end,$alur_perkara_id='in (1)');
        $data['qPemberitahuanPidana'] = $this->Model->getPemberitahuanPutusanPidana($date_start,$date_end,$alur_perkara_id='in (111,112,113,115,118)');

        $data['appName'] = $this->db2->get_where('sys_config',array('id'=>'5'))->row()->value;
        $data['namasatker'] = $this->db2->get_where('sys_config',array('id'=>'62'))->row()->value;

        $data['sys_config1'] = $this->db2->get('sys_config');
        $data['page'] ='home/dashboard2';
        $this->template->admin($data);
    }

    private function getTergetArray($data ,$idIndikator){
        $target = false;
        foreach ($data as $value) {
            if($value->id_indikator == $idIndikator){
                $target = $value->target;
            }
        }
        return $target;
    }

    private function getTrend($var1,$var2)
    {
        if($var1 > $var2)
        {
            $trend = 'fa fa-arrow-circle-down text-danger';
        }elseif($var1 < $var2){
            $trend = 'fa fa-arrow-circle-up text-success';
        }else{
            $trend = '';
        }
        return $trend;
    }

    function loadIndikatorData()
    {
        $indikator = $this->input->post('indikator',TRUE);
        $jenis_laporan = $this->input->post('indikator',TRUE);
        $year = $this->input->post('year',TRUE);
        $qTarget = $this->Model_dash->getTarget($year);
        $date_start = $year.'-01'; 
        $date_end = $year.'-12';
        $dtTarget = $qTarget->result();
        $draw = '';
        $pQ = 0;
        $selisihPQ = 0;
        $trend = '';
        $persen_capaian = '0';

        if(in_array($jenis_laporan,array(1,2,21,22)))
        {
            if($jenis_laporan=='1')
            {
                $alur_perkara_id = ' in  ("1","2","3","4","5","7","8","18")  ';
            }elseif($jenis_laporan=='2')
            {
                $alur_perkara_id = ' in (111,112,113,118,119)  ';
            }elseif($jenis_laporan=='21')
            {
                $alur_perkara_id = ' = 6  ';
            }elseif($jenis_laporan=='22')
            {
                $alur_perkara_id = ' = 115  ';
            }else{
                $alur_perkara_id = '';
            }
        }else{
            $alur_perkara_id = '';
        }

        $arr_pen_perkara = array('1','2','21','22');
        if(in_array($jenis_laporan,$arr_pen_perkara))
        {
            $q = $this->Model->getPerkaraTepatWaktu($date_start,$date_end,$alur_perkara_id,$jenis_laporan);
        }

        $arr_rj = array('3');
        if(in_array($jenis_laporan,$arr_rj))
        {
            $q = $this->Model->getRJ($date_start,$date_end,$jenis_laporan);
        }

        $arr_jen_tepat_waktu = array('4');
        if(in_array($jenis_laporan,$arr_jen_tepat_waktu))
        {
            $q = $this->Model->getTidakBanding($date_start,$date_end,$alur_perkara_id);
        }

        $arr_jen_tepat_waktu = array('5');
        if(in_array($jenis_laporan,$arr_jen_tepat_waktu))
        {
            $q = $this->Model->getTidakKasasi($date_start,$date_end,$alur_perkara_id);
            // print_r($q->result());
        }

        $arr_jen_tepat_waktu = array('6');
        if(in_array($jenis_laporan,$arr_jen_tepat_waktu))
        {
            $q = $this->Model->getDiversi($date_start,$date_end,$alur_perkara_id);
        }

        if($jenis_laporan=='7'){
            $q = $this->Model->getPersepsiIKM($date_start,$date_end,$jenis_laporan);       
        }

        if($jenis_laporan=='8'){
            $q = $this->Model->getPemberitahuanPutusanPerdata($date_start,$date_end,$alur_perkara_id);
        }

        if($jenis_laporan=='9'){
            $q = $this->Model->getPemberitahuanPutusanPidana($date_start,$date_end,$alur_perkara_id);
        }

        if($jenis_laporan=='10'){
            $q = $this->Model->getMediasi($date_start,$date_end,$alur_perkara_id);      
        }

        if($jenis_laporan=='11'){
            $q = $this->Model->getProdeo($date_start,$date_end,$alur_perkara_id);     
        }
        
        if($jenis_laporan=='12'){
            $q = $this->Model->getSidangKeliling($date_start,$date_end,$alur_perkara_id);   
        }

        if($jenis_laporan=='13'){
            $q = $this->Model->getPosbakum($date_start,$date_end,$jenis_laporan);       
        }

        if($jenis_laporan=='14'){
            $q = $this->Model->getEksekusi($date_start,$date_end,$alur_perkara_id);        
        }

        if($jenis_laporan=='23'){
            $q = $this->db2->get_where('sys_config',array('id'=>0));   
        }

        if($q->num_rows() > 0)
        {
            $dt = $q->row();
            if(in_array($jenis_laporan,array('1','2','21','22'))){
                $val_penyebut  = $dt->totalperkara; 
                $val_pembilang = $dt->totaltepatwaktu;
            }
            if(in_array($jenis_laporan,array('3'))){
                $val_penyebut = $dt->totalpermohonanrj;
                $val_pembilang = $dt->totalputusrj;
            }
            if(in_array($jenis_laporan,array('4'))){
                $val_penyebut = $dt->totalperkara;
                $val_pembilang = $dt->tdk_banding;
            }
            if(in_array($jenis_laporan,array('5'))){
                $val_penyebut = $dt->totalperkara;
                $val_pembilang = $dt->tidak_kasasi;
            }
            if(in_array($jenis_laporan,array('6'))){
                $val_penyebut = $dt->perkarapidanaanak;
                $val_pembilang = $dt->diversiberhasil;
            }
            if(in_array($jenis_laporan,array('7'))){
                $val_pembilang = $dt->totalPenyebut;
                $val_penyebut = $dt->totalRecord;
            }
            if(in_array($jenis_laporan,array('8'))){
                $val_penyebut = $dt->jumlahperkara;
                $val_pembilang = $dt->as_tidak_terlambat;
            }
            if(in_array($jenis_laporan,array('9'))){
                $val_penyebut = $dt->jumlahperkara;
                $val_pembilang = $dt->as_tidak_terlambat;
            }
            if(in_array($jenis_laporan,array('10'))){
                $val_penyebut = $dt->is_mediasi_done;
                $val_pembilang = $dt->mediasidilaksanakan;
            }
            if(in_array($jenis_laporan,array('11'))){
                $val_penyebut = $dt->as_prodeo;
                $val_pembilang = $dt->as_putus_prodeo;
            }
            if(in_array($jenis_laporan,array('12'))){
                $val_penyebut = $dt->totalpermohonanrj;
                $val_pembilang = $dt->totalputusrj;
            }
            if(in_array($jenis_laporan,array('13'))){
                $val_penyebut = $dt->totalPenyebut;
                $val_pembilang = $dt->totalPembilang;
            }
            if(in_array($jenis_laporan,array('14'))){
                $val_penyebut = $dt->permohonaneksekusi;
                $val_pembilang = $dt->pelaksanaaneksekusi;
            }
            if(in_array($jenis_laporan,array('23'))){
                $val_penyebut = '';
                $val_pembilang = '';
            }
            

            if(!empty($val_penyebut) OR $val_penyebut > 0)
            {
                if($jenis_laporan=='7'){
                    $pQ = ($val_pembilang/$val_penyebut);
                }else{
                    $pQ = ($val_pembilang/$val_penyebut)*100;
                }
            }else{
                $pQ = 0;
            }

            $qTQ = $this->getTergetArray($dtTarget,$jenis_laporan);
            $trend = $this->getTrend($qTQ,$pQ);
            $selisihPQ = $pQ-$qTQ;

            if($qTQ != 0){
                $persen_capaian_tmp = ($pQ/$qTQ)*100;
                if($persen_capaian_tmp=='0'){
                    $persen_capaian = 0;
                }elseif($persen_capaian_tmp=='100'){
                    $persen_capaian = 100;
                }else{
                    $persen_capaian = number_format($persen_capaian_tmp,2,".",".");
                }
            }else{
                $persen_capaian = '0';
            }
        }

        
        $unit = '%';
        if(is_float($pQ)){
            $unitValue =  number_format($pQ,2,".",".");
        }else{
            $unitValue = $pQ;
        }

        if(is_float($selisihPQ))
        {
            $selisih = number_format($selisihPQ,2,".",".");
        }else{
            $selisih = $selisihPQ;
        }

        $star = '<div style="margin-top: -10px;">';
        $flasg_star = round(2*$persen_capaian)/2;
        if($flasg_star >= 0 && $flasg_star <= 20)
        {
            $star .= '<i class="fa fa-star checked f-small"></i><i class="fa fa-star f-small"></i><i class="fa fa-star f-small"></i><i class="fa fa-star f-small"></i><i class="fa fa-star f-small"></i>';
        }elseif($flasg_star > 20 && $flasg_star <= 40)
        {
            $star .= '<i class="fa fa-star checked f-small"></i><i class="fa fa-star checked f-small"></i><i class="fa fa-star f-small"></i><i class="fa fa-star f-small"></i><i class="fa fa-star f-small"></i>';
        }elseif($flasg_star > 40 && $flasg_star <= 60)
        {
            $star .= '<i class="fa fa-star checked f-small"></i><i class="fa fa-star checked f-small"></i><i class="fa fa-star checked f-small"></i><i class="fa fa-star f-small"></i><i class="fa fa-star f-small"></i>';
        }elseif($flasg_star > 60 && $flasg_star <= 80)
        {
            $star .= '<i class="fa fa-star checked f-small"></i><i class="fa fa-star checked f-small"></i><i class="fa fa-star checked f-small"></i><i class="fa fa-star checked f-small"></i><i class="fa fa-star f-small"></i>';
        }elseif($flasg_star > 80)
        {
            $star .= '<i class="fa fa-star checked f-small"></i><i class="fa fa-star checked f-small"></i><i class="fa fa-star checked f-small"></i><i class="fa fa-star checked f-small"></i><i class="fa fa-star checked f-small"></i>';
        }
        $star .= '</div>';


        $draw .= '  <div class="text-lg font-weight-bold align-items-right">'.$unitValue.''.$unit.'</div>
                    <div class="text-xs font-weight-bold text-white d-inline-flex">
                        REALISASI &nbsp;&nbsp;
                        <i class="'.$trend.' mr-1" ></i>
                        '.$selisih.''.$unit .'
                    </div>';

        echo json_encode(array('st'=>'1','trend'=>$trend,'realisasi'=>$unitValue,'selisih_trend'=>$selisih,'persen_capaian'=>$persen_capaian.'%</br>'.$star,'rating'=>$star));
    }


}
