<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Home extends MY_Controller {
    function __construct() {
        parent::__construct();
        // $this->load->model('evakip/M_monev_sakip','Model_eval');
        $this->load->model('evakip/M_monev_sakip','Model');
        $this->load->model('M_dashboard','Model_dash');
        $this->db2 = $this->load->database('evakip', TRUE);
    }

    public function index()
    {
        $post = $this->input->post();
        if(!empty($post)){
			$month_start = $this->input->post('month_start');
			$year_start = $this->input->post('year_start');
            $month_end = $this->input->post('month_end');
			$year_end = $this->input->post('year_end');
		}else{
			$month_start = '01';
			$year_start = date('Y');
            $month_end = date('m');
			$year_end = date('Y');
		}

        $year = $year_end;
        $data['year'] = $year_end;
        $data['bulan_mulai'] = $month_start;
        $data['tahun_mulai'] = $year_start;
        $data['bulan_akhir'] = $month_end;
        $data['tahun_akhir'] = $year_end;

        $arrMonth = array(
            '' => '--pilih bulan--',
            '01' => 'Januari',
            '02' => 'Februari',
            '03' => 'Maret',
            '04' => 'April',
            '05' => 'Mei',
            '06' => 'Juni',
            '07' => 'Juli',
            '08' => 'Agustus',
            '09' => 'September',
            '10' => 'Oktober',
            '11' => 'November',
            '12' => 'Desember');
        
        $qYear = $this->Model->getTahunPerkara();
        $arrYear = array();
        $arrYear['0'] = "--pilih tahun--";
        foreach($qYear->result() as $row)
        {
            $arrYear[$row->year_sel] = $row->year_sel; 
        }
        $data['arrYear'] = $arrYear;
        $data['arrMonth'] = $arrMonth;

        $date_start = $year_start.'-'.$month_start;
        $date_end = $year_end.'-'.$month_end;
        $data['qTarget'] = $this->Model_dash->getTarget($year);
        $data['qGlobalIndikator'] = $this->Model_dash->globalIndikator($year);
        $data['qKasasi'] = $this->Model->getTidakKasasi($year);
        $data['qTrxLaporanIKM'] = $this->Model->getTrxLaporanIKM($year);
        $data['qPemberitahuanPerdata'] = $this->Model->getPemberitahuanPerdata($year);
        $data['qPemberitahuanPidana'] = $this->Model->getPemberitahuanPidana($year);
        
        $data['sys_config1'] = $this->db2->get('sys_config');
        $data['page'] ='home/dashboard2';
        $this->template->admin($data);
    }

    private function getTergetArray($data ,$idIndikator){
        $target = false;
        foreach ($data as $value) {
            if($value->id_indikator == $idIndikator){
                $target = $value->target;
            }
        }
        return $target;
    }

    private function getTrend($var1,$var2)
    {
        if($var1 > $var2)
        {
            $trend = 'fa fa-arrow-circle-down';
        }else{
            $trend = 'fa fa-arrow-circle-up';
        }
        return $trend;
    }

    function loadIndikatorData()
    {
        $indikator = $this->input->post('indikator',TRUE);
        $year = $this->input->post('year',TRUE);
        $qTarget = $this->Model->getTarget($year);
        $dtTarget = $qTarget->result();
        $draw = '';

        if($indikator=='1'){
            $q = $this->Model->globalIndikator($year);
            if($q->num_rows() > 0)
            {
                $dt = $q->row();
                // $dtPBTPDT =  $q->row();
                $jumlahperdata  = $dt->jumlahperkaraperdata; 
                $jumlahperdatatepatwaktu = $dt->jumlahperdatatepatwaktu;
                
                if(!empty($jumlahperdata) OR $jumlahperdata > 0)
                {
                    $pQ = ($jumlahperdatatepatwaktu/$jumlahperdata)*100;
                }else{
                    $pQ = 0;
                }
                $qTQ = $this->getTergetArray($dtTarget,1);
                $trend = $this->getTrend($qTQ,$pQ);
                $selisihPQ = $pQ-$qTQ;
            }
        }if($indikator=='21'){
            $q = $this->Model->globalIndikator($year);
            if($q->num_rows() > 0)
            {
                $dt = $q->row();
                // $dtPBTPDT =  $q->row();
                $jumlahperdataphi  = $dt->jumlahperkaraperdataphi; 
                $jumlahperdatatepatwaktu_phi = $dt->jumlahperkaraperdataphi_tw;
                
                if(!empty($jumlahperdataphi) OR $jumlahperdatatepatwaktu_phi > 0)
                {
                    $pQ = ($jumlahperdatatepatwaktu_phi/$jumlahperdataphi)*100;
                }else{
                    $pQ = 0;
                }
                $qTQ = $this->getTergetArray($dtTarget,21);
                $trend = $this->getTrend($qTQ,$pQ);
                $selisihPQ = $pQ-$qTQ;
            }
        }elseif($indikator=='2'){
            $q = $this->Model->globalIndikator($year);
            if($q->num_rows() > 0)
            {
                $dt = $q->row();
                $jumlahperkarapidana  = $dt->jumlahperkarapidana; 
                $jumlahpidanatepatwaktu = $dt->jumlahpidanatepatwaktu;
                if(!empty($jumlahperkarapidana) OR $jumlahperkarapidana > 0)
                {
                    $pQ = ($jumlahpidanatepatwaktu/$jumlahperkarapidana)*100;
                }else{
                    $pQ = 0;
                }
                $qTQ = $this->getTergetArray($dtTarget,2);
                $trend = $this->getTrend($qTQ,$pQ);
                $selisihPQ = $pQ-$qTQ;

            }
        }elseif($indikator=='22'){
            $q = $this->Model->globalIndikator($year);
            if($q->num_rows() > 0)
            {
                $dt = $q->row();
                $jumlahperkarapidana_tpk  = $dt->jumlahperkaratipikor; 
                $jumlahpidana_tpk_tepatwaktu = $dt->jumlahperkaratipikor_tw;
                if(!empty($jumlahperkarapidana_tpk) OR $jumlahpidana_tpk_tepatwaktu > 0)
                {
                    $pQ = ($jumlahpidana_tpk_tepatwaktu/$jumlahperkarapidana_tpk)*100;
                }else{
                    $pQ = 0;
                }
                $qTQ = $this->getTergetArray($dtTarget,22);
                $trend = $this->getTrend($qTQ,$pQ);
                $selisihPQ = $pQ-$qTQ;
            }
        }elseif($indikator=='3'){
            $q = $this->Model->getRJ($year);
            if($q->num_rows() > 0)
            {
                $dt = $q->row();
                $totalpermohonanrj  = $dt->totalpermohonanrj; 
                $totalputusrj = $dt->totalputusrj;
                // $pQ = (!empty($totalputusrj) ? $totalputusrj : '0');
                if(!empty($totalpermohonanrj) OR $totalpermohonanrj > 0)
                {
                    $pQ = ($totalputusrj/$totalpermohonanrj)*100;
                }else{
                    $pQ = 0;
                }
                $qTQ = $this->getTergetArray($dtTarget,3);
                $trend = $this->getTrend($qTQ,$pQ);
                $selisihPQ = $pQ-$qTQ;

            }
        }elseif($indikator=='4'){
            $q = $this->Model->globalIndikator($year);
            if($q->num_rows() > 0)
            {
                $dt = $q->row();
                $totalperkaraputus_q4  = $dt->totalperkaraputus_q4; 
                $permohonanbanding_q4 = $dt->permohonanbanding_q4;
                if(!empty($totalperkaraputus_q4) OR $totalperkaraputus_q4 > 0)
                {
                    $pQ = (($totalperkaraputus_q4-$permohonanbanding_q4)/$totalperkaraputus_q4)*100;
                }else{
                    $pQ = 0;
                }
                $qTQ = $this->getTergetArray($dtTarget,4);
                $trend = $this->getTrend($qTQ,$pQ);
                $selisihPQ = $pQ-$qTQ;

            }
        }elseif($indikator=='5'){
            $q = $this->Model->getTidakKasasi($year);
            if($q->num_rows() > 0)
            {
                $dt = $q->row();
                $putusanbanding  = $dt->putusanbanding; 
                $kasasi = $dt->kasasi;
                if(!empty($putusanbanding) OR $putusanbanding > 0)
                {
                    $pQ = (($putusanbanding-$kasasi)/$putusanbanding)*100;
                }else{
                    $pQ = 0;
                }
                $qTQ = $this->getTergetArray($dtTarget,5);
                $trend = $this->getTrend($qTQ,$pQ);
                $selisihPQ = $pQ-$qTQ;

            }
        }elseif($indikator=='6'){
            $q = $this->Model->globalIndikator($year);
            if($q->num_rows() > 0)
            {
                $dt = $q->row();
                $diversiberhasil_q6  = $dt->diversiberhasil_q6; 
                $perkarapidanaanak_q6 = $dt->perkarapidanaanak_q6;
                if(!empty($perkarapidanaanak_q6) OR $perkarapidanaanak_q6 > 0)
                {
                    $pQ = ($diversiberhasil_q6/$perkarapidanaanak_q6)*100;
                }else{
                    $pQ = 0;
                }
                $qTQ = $this->getTergetArray($dtTarget,6);
                $trend = $this->getTrend($qTQ,$pQ);
                $selisihPQ = $pQ-$qTQ;

            }
        }elseif($indikator=='7'){
            $q = $this->Model->getTrxLaporanIKM($year);
            if($q->num_rows() > 0)
            {
                $dt = $q->row();
                $jumlahIKM  = $dt->jumlahIKM; 
                $penyebutIKM = $dt->penyebutIKM;
                if(!empty($jumlahIKM) OR $jumlahIKM > 0)
                {
                    $pQ = $penyebutIKM/$jumlahIKM;
                }else{
                    $pQ = 0;
                }
                // $pQ = (!empty($totalputusrj) ? $totalputusrj : '0');
                $qTQ = $this->getTergetArray($dtTarget,7);
                $trend = $this->getTrend($qTQ,$pQ);
                $selisihPQ = $pQ-$qTQ;

            }
        }elseif($indikator=='8'){
            $q = $this->Model->getPemberitahuanPerdata($year);
            if($q->num_rows() > 0)
            {
                $dtPBTPDT =  $q->row();
                $as_tepatwaktu  = $dtPBTPDT->as_tepatwaktu; 
                $jumlahperkara  = $dtPBTPDT->jumlahperkara; 
                
                if(!empty($jumlahperkara) OR $jumlahperkara > 0)
                {
                    $pQ = ($as_tepatwaktu/$jumlahperkara)*100;
                }else{
                    $pQ = 0;
                }
                $qTQ = $this->getTergetArray($dtTarget,8);
                $trend = $this->getTrend($qTQ,$pQ);
                $selisihPQ = $pQ-$qTQ;
            }
        }elseif($indikator=='9'){
            $qPemberitahuanPidana = $this->Model->getPemberitahuanPidana($year);
            if($qPemberitahuanPidana->num_rows() > 0)
            {
                $dtPBTPDT =  $qPemberitahuanPidana->row();
                $as_tepatwaktu  = $dtPBTPDT->as_tepatwaktu; 
                $jumlahperkara  = $dtPBTPDT->jumlahperkara; 
                
                if(!empty($jumlahperkara) OR $jumlahperkara > 0)
                {
                    $pQ = ($as_tepatwaktu/$jumlahperkara)*100;
                }else{
                    $pQ = 0;
                }
                $qTQ = $this->getTergetArray($dtTarget,9);
                $trend = $this->getTrend($qTQ,$pQ);
                $selisihPQ = $pQ-$qTQ;
            }
        }elseif($indikator=='10'){
            $q = $this->Model->getMediasi($year);
            if($q->num_rows() > 0)
            {
                $dt =  $q->row();
                $qTQ = $this->getTergetArray($dtTarget,10);
                $berhasilmediasi  = $dt->berhasilmediasi; 
                $jumlahperkaraMds  = $dt->jumlahperdata; 

                if(!empty($jumlahperkaraMds) OR $jumlahperkaraMds > 0)
                {
                    $pQ = ($berhasilmediasi/$jumlahperkaraMds)*100;
                }else{
                    $pQ = 0;
                }

                $trend = $this->getTrend($qTQ,$pQ);
                $selisihPQ = $pQ-$qTQ;
                // echo $selisihPQ;
            }
        }elseif($indikator=='11'){
            $q = $this->Model->getProdeo($year);
            if($q->num_rows() > 0)
            {
                $dt =  $q->row();
                $as_prodeo  = $dt->as_prodeo; 
                $jumlahperkaraprod  = $dt->jumlah_perkara; 
                
                if(!empty($jumlahperkaraprod) OR $jumlahperkaraprod > 0)
                {
                    $pQ = ($as_prodeo/$jumlahperkaraprod)*100;
                }else{
                    $pQ = 0;
                }
                $qTQ = $this->getTergetArray($dtTarget,11);
                $trend = $this->getTrend($qTQ,$pQ);
                $selisihPQ = $pQ-$qTQ;
            }
        }elseif($indikator=='12'){
            $q = $this->Model->getSiKel($year);
            if($q->num_rows() > 0)
            {
                $dt =  $q->row();
                $sikel_putus  = $dt->sikel_putus; 
                $jumlahperkarasikel  = $dt->sikel; 
                
                if(!empty($jumlahperkarasikel) OR $jumlahperkarasikel > 0)
                {
                    $pQ = ($sikel_putus/$jumlahperkarasikel)*100;
                }else{
                    $pQ = 0;
                }
                $qTQ = $this->getTergetArray($dtTarget,12);
                $trend = $this->getTrend($qTQ,$pQ);
                $selisihPQ = $pQ-$qTQ;
            }
        }elseif($indikator=='13'){
            $q = $this->Model->getPosbakum($year);
            // print_r($q->result());
            if($q->num_rows() > 0)
            {
                $dt =  $q->row();
                $jumlah_record  = $dt->jumlah_record; 
                $pembilang  = $dt->pembilang; 
                $penyebut  = $dt->penyebut; 

                if(!empty($jumlah_record) OR $jumlah_record > 0)
                {
                    $pQ = ($pembilang/$jumlah_record);
                }else{
                    $pQ = 0;
                }
                $qTQ = $this->getTergetArray($dtTarget,13);
                $trend = $this->getTrend($qTQ,$pQ);
                $selisihPQ = $pQ-$qTQ;
            }
        }elseif($indikator=='14'){
            $q = $this->Model->getEksekusi($year);
            if($q->num_rows() > 0)
            {
                $dt =  $q->row();
                $permohonaneksekusi  = $dt->permohonaneksekusi; 
                $pelaksanaaneksekusi  = $dt->pelaksanaaneksekusi; 

                if(!empty($permohonaneksekusi) OR $permohonaneksekusi > 0)
                {
                    $pQ = ($pelaksanaaneksekusi/$permohonaneksekusi)*100;
                }else{
                    $pQ = 0;
                }
                $qTQ = $this->getTergetArray($dtTarget,14);
                $trend = $this->getTrend($qTQ,$pQ);
                $selisihPQ = $pQ-$qTQ;
            }
        }

        // $arrUnitPerscent = array('3');
        // if(in_array($indikator,$arrUnitPerscent))
        // {
        //     $unitValue =  $pQ;
        //     $unit = ' Pkr';
        // }else
        // {
        //     $unit = '%';
        //     if(is_float($pQ)){
        //         $unitValue =  number_format($pQ,2,".",".");
        //     }else{
        //         $unitValue = $pQ;
        //     }
        // }

        $unit = '%';
        if(is_float($pQ)){
            $unitValue =  number_format($pQ,2,".",".");
        }else{
            $unitValue = $pQ;
        }

        if(is_float($selisihPQ))
        {
            $selisih = number_format($selisihPQ,2,".",".");
        }else{
            $selisih = $selisihPQ;
        }

        $star = '';
        $flasg_star = round(2*$unitValue)/2;
        if($flasg_star > 0 && $flasg_star <= 20)
        {
            $star .= '<i class="fa fa-star checked"></i><i class="fa fa-star "></i><i class="fa fa-star "></i><i class="fa fa-star "></i><i class="fa fa-star "></i>';
        }elseif($flasg_star > 20 && $flasg_star <= 40)
        {
            $star .= '<i class="fa fa-star checked"></i><i class="fa fa-star checked"></i><i class="fa fa-star "></i><i class="fa fa-star "></i><i class="fa fa-star "></i>';
        }elseif($flasg_star > 40 && $flasg_star <= 60)
        {
            $star .= '<i class="fa fa-star checked"></i><i class="fa fa-star checked"></i><i class="fa fa-star checked"></i><i class="fa fa-star "></i><i class="fa fa-star "></i>';
        }elseif($flasg_star > 60 && $flasg_star <= 80)
        {
            $star .= '<i class="fa fa-star checked"></i><i class="fa fa-star checked"></i><i class="fa fa-star checked"></i><i class="fa fa-star checked"></i><i class="fa fa-star "></i>';
        }elseif($flasg_star > 80)
        {
            $star .= '<i class="fa fa-star checked"></i><i class="fa fa-star checked"></i><i class="fa fa-star checked"></i><i class="fa fa-star checked"></i><i class="fa fa-star checked"></i>';
        }


        $draw .= '  <div class="text-lg font-weight-bold align-items-right">'.$unitValue.''.$unit.'</div>
                    <div class="text-xs font-weight-bold text-white d-inline-flex">
                        REALISASI &nbsp;&nbsp;
                        <i class="'.$trend.' mr-1" ></i>
                        '.$selisih.''.$unit .'
                    </div>';

        echo json_encode(array('st'=>'1','draw'=>$draw,'rating'=>$star));
    }


}
