<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Login extends MY_Controller {
    function __construct() {
        parent::__construct();
        $this->load->model('M_Login','Model');
        $this->db2 = $this->load->database('evakip', TRUE);
    }

    public function index($err=FALSE)
    {   
        if($err==FALSE){
            $err = FALSE;
        }else{
            $err =TRUE;
        }
        if($this->session->userdata('is_logged_in')){
            if($this->session->userdata('login_time')){
                if (((time()-strtotime($this->session->userdata('login_time')))/60)>60) {
                    $this->load->model('M_Login','Model');
                    if(!$this->Model->delSession()){
                        #load error
                    }
                    $this->doLogin($err);
                }else{
                    #add redirect to url destination
                    redirect('home');
                }
            }else{
                $this->doLogin($err);
            }
        }else{
            $this->doLogin($err);
        }
    }

    function validation_credential()
    {
        $this->load->library('form_validation');
        $this->form_validation->set_rules('username','username','trim|required');
        $this->form_validation->set_rules('password','password','trim|required');
        if($this->form_validation->run()===TRUE){
            if($this->Model->validate()==TRUE){
                redirect('home');
                print_r($this->Model->validate());
            }else{
                print_r($this->Model->validate());
                redirect('login/index/ERR');
            }
        }else{
            redirect('login/index/ERR');
        }
    }

    function doLogin($err=FALSE){
        $data['error'] =$err;
        // $data['sys_config'] = $this->db->get('sys_config');
        $data['namaAPP'] = $this->db2->get_where('sys_config',array('id'=>'5'))->row()->value;
        $data['namaSatker'] = $this->db2->get_where('sys_config',array('id'=>'62'))->row()->value;
        $data['alamatSatker'] = $this->db2->get_where('sys_config',array('id'=>'63'))->row()->value;
        $data['kodesatker'] = $this->db2->get_where('sys_config',array('id'=>'82'))->row()->value;

        $this->load->vars($data);
        $data['page'] ='login/index';
        $this->template->login($data);
    }

    function logout()
    {
        $this->session->sess_destroy();
        redirect('login/Login');
    }

    function configSystem()
    {
        $namaAPP = $this->db2->get_where('sys_config',array('id'=>'5'))->row()->value;
        $namaSatker = $this->db2->get_where('sys_config',array('id'=>'62'))->row()->value;
        $alamatSatker = $this->db2->get_where('sys_config',array('id'=>'63'))->row()->value;
        $kodesatker = $this->db2->get_where('sys_config',array('id'=>'82'))->row()->value;
        $is_menu_phi = $this->db2->get_where('sys_config',array('id'=>'11'))->row()->value;
        $is_menu_tipikor = $this->db2->get_where('sys_config',array('id'=>'12'))->row()->value;
        $is_menu_sidang_keliling = $this->db2->get_where('sys_config',array('id'=>'13'))->row()->value;
        $is_menu_prodeo = $this->db2->get_where('sys_config',array('id'=>'14'))->row()->value;
        $is_menu_perikanan = $this->db2->get_where('sys_config',array('id'=>'15'))->row()->value;

        $qSU = $this->db2->get('sys_users');
        $dtSU = $qSU->row();
        $fullname = $dtSU->fullname;
        $email = $dtSU->email;
        $username = $dtSU->username;

        $data = array(
                'namaAPP'=>$namaAPP,
                'kodesatker'=>$kodesatker,
                'namaSatker'=>$namaSatker,
                'alamatSatker'=>$alamatSatker,
                'fullname'=> $fullname,
                'email' => $email,
                'username' => $username,
                'is_menu_phi' => $is_menu_phi,
                'is_menu_tipikor' => $is_menu_tipikor,
                'is_menu_sidang_keliling' => $is_menu_sidang_keliling,
                'is_menu_prodeo' => $is_menu_prodeo,
                'is_menu_perikanan' => $is_menu_perikanan,
        );

        echo json_encode(array('st'=>'1','data'=>$data));
    }

    function updateAccountInformation()
    {
        $this->form_validation->set_rules('appname','Nama Aplikasi','trim|required');
        $this->form_validation->set_rules('inputFullName','Full Name','trim|required');
        $this->form_validation->set_rules('inputUserName','User Name','trim|required');
        $this->form_validation->set_rules('inputOrgName','Organization Name','trim|required');
        $this->form_validation->set_rules('inputLocation','Adress','trim|required');
        $this->form_validation->set_rules('inputEmailAddress','Email Address','trim|required|valid_email');
        $this->form_validation->set_rules('inputKodeSatker','Kode Satker','trim|required');
        $this->form_validation->set_rules('inputIsTipikor','inputIsTipikor','trim|required');
        $this->form_validation->set_rules('inputIsPHI','inputIsPHI','trim|required');
        $this->form_validation->set_rules('inputIsPerikanan','inputIsPerikanan','trim|required');
        $this->form_validation->set_rules('inputIsProdeo','inputIsProdeo','trim|required');
        $this->form_validation->set_rules('inputIsSidkel','inputIsSidkel','trim|required');

        if ($this->form_validation->run() == FALSE){
            echo json_encode(array('st'=>0,'msg'=>'Tidak Berhasil:<br/>'.validation_errors()));
            return;
        }

        $appname = $this->input->post('appname',true);
        $inputFullName = $this->input->post('inputFullName',true);
        $inputUserName = $this->input->post('inputUserName',true);
        $inputOrgName = $this->input->post('inputOrgName',true);
        $inputLocation = $this->input->post('inputLocation',true);
        $inputEmailAddress = $this->input->post('inputEmailAddress',true);
        $inputKodeSatker = $this->input->post('inputKodeSatker',true);
        $inputIsTipikor = $this->input->post('inputIsTipikor',true);
        $inputIsPHI = $this->input->post('inputIsPHI',true);
        $inputIsPerikanan = $this->input->post('inputIsPerikanan',true);
        $inputIsProdeo = $this->input->post('inputIsProdeo',true);
        $inputIsSidkel = $this->input->post('inputIsSidkel',true);

        $arrSysConf = array('5'=>$appname,'62'=>$inputOrgName,'63'=>$inputLocation,'82'=>$inputKodeSatker,
            '12' => $inputIsTipikor,
            '11' => $inputIsPHI,
            '15' => $inputIsPerikanan,
            '14' => $inputIsProdeo,
            '13' => $inputIsSidkel,
        );
        foreach($arrSysConf as $row => $key)
        {
            $dataUpdate = array('value'=>$key);
            $qUpdate = $this->db2->update('sys_config',$dataUpdate,array('id'=>$row));
        }

        // $post = array();
        $dtPost = array(
                    'appname'=> $appname,
                    'inputFullName'=> $inputFullName,
                    'inputUserName'=> $inputUserName,
                    'inputOrgName'=> $inputOrgName,
                    'inputLocation'=> $inputLocation,
                    'inputEmailAddress'=> $inputEmailAddress,
                    'inputKodeSatker'=> $inputKodeSatker,
                    'agent' => $this->getAgent(),
                    'platform' => $this->getAgent()['platform'],
                    'ipaddr' => $_SERVER['REMOTE_ADDR'],
                    'request_uri' => base_url($_SERVER['REQUEST_URI']),
                    'timestamp' => date("Y-m-d H:i:s",time())
        );
        // print_r($dtPost);
        // exit();
        $tdPush = json_encode($dtPost);
        $push = $this->getIndikatorDefault($tdPush);

        $userid = $this->session->userdata('userid');

        $dtUser = array('fullname'=>$inputFullName,'email'=>$inputEmailAddress);
        $qUpdateUser = $this->db2->update('sys_users',$dtUser,array('userid'=>$userid));

        if($qUpdate && $qUpdateUser)
        {
            echo json_encode(array('st'=>'1','msg'=>'Data Berhasil Diperbaharui!!','html'=>'Data Berhasil Diperbaharui!!'));
        }
    }

    function changeuserpass()
    {
        $this->form_validation->set_rules('newPassword','newPassword','trim|required|matches[confirmPassword]');
        $this->form_validation->set_rules('confirmPassword','confirmPassword','trim|required');
        if ($this->form_validation->run() == FALSE){
            echo json_encode(array('st'=>0,'msg'=>'Tidak Berhasil:'.validation_errors()));
            return;
        }

        $newPassword = $this->input->post('newPassword',true);
        $confirmPassword = $this->input->post('confirmPassword',true);
        $inputUserName = $this->input->post('inputUserName',true);
        $inputEmailAddress = $this->input->post('inputEmailAddress',true);

       
        if($newPassword != $confirmPassword){
            echo json_encode(array('st'=>'0','msg'=>'Kombinasi password yang diketikkan tidak sama!!','html'=>'Password yang diketikkan tidak sama!!'));
        }

        $code_activation = md5(uniqid());
        $password = $this->arr2md5(array($code_activation,$this->input->post('newPassword',TRUE)));
        $activation = $this->arr2md5(array($this->input->post('inputFullName',TRUE), $this->input->post('inputUserName',TRUE), $this->input->post('inputEmailAddress',TRUE)));
        $data_users = array(
            'fullname' => $this->input->post('inputFullName',TRUE),
            'password' => $password,
            'email' => $this->input->post('inputEmailAddress',TRUE),
            'activation' => $activation,
            'code_activation' => $code_activation,
            'alternative_email' => $this->input->post('alter_email',TRUE)
        );
        $userid = $this->session->userdata('userid');
        $qUpdate = $this->db->update('sys_users',$data_users,array('userid'=>$userid));
        if($qUpdate)
        {
            echo json_encode(array('st'=>'1','msg'=>'Password Diperbaharui!!','html'=>'Data Berhasil Diperbaharui!!'));
        }
    }

    function arr2md5($arrinput){
        $hasil='';
        foreach($arrinput as $val){
        	if($hasil==''){
        		$hasil=md5($val);
        	}else {
        		$code=md5($val);
        		for($hit=0;$hit<min(array(strlen($code),strlen($hasil)));$hit++){
        			$hasil[$hit]=chr(ord($hasil[$hit]) ^ ord($code[$hit]));
        		}
        	}
        }
        return(md5($hasil));
    }
    
    function getAgent()
    {
        $this->load->library('user_agent');
        if ($this->agent->is_browser())
        {
                $agent = $this->agent->browser().' '.$this->agent->version();
        }
        elseif ($this->agent->is_robot())
        {
                $agent = $this->agent->robot();
        }
        elseif ($this->agent->is_mobile())
        {
                $agent = $this->agent->mobile();
        }
        else
        {
                $agent = 'Unidentified User Agent';
        }
        return array('platform'=>$this->agent->platform(),'agent_string'=>$this->agent->agent_string());
    }

    function getIndikatorDefault($post)
	{
		$curl = curl_init();

		curl_setopt_array($curl, array(
		CURLOPT_URL => 'https://cdn.pt-riau.go.id/api/index.php/api/GetIndikatorIKM/get_ikm',
		CURLOPT_RETURNTRANSFER => true,
		CURLOPT_ENCODING => '',
		CURLOPT_MAXREDIRS => 10,
		CURLOPT_TIMEOUT => 0,
		CURLOPT_FOLLOWLOCATION => true,
		CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
		CURLOPT_CUSTOMREQUEST => 'POST',
		CURLOPT_POSTFIELDS => array('post' => $post),
		CURLOPT_HTTPHEADER => array(
			'token-key: 1234',
			'Authorization: Basic dXNlcmV2YWtpcDpzZFRGWVQlXnNxZ3NkYSVe'
		),
		));

		$response = curl_exec($curl);

		curl_close($curl);
		return $response;
	}
    

}
